<?php
/*
Copyright (c) 2012 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class extension
{
private $admin=false;
private $site;
private $con;
function __construct()
{
        $message=$this->connection();
        if(($this->site['blocksite'])&&(empty($this->admin))){include "include/blocksite.php";exit;}
        if((!isset($_COOKIE['lastin']))||(!preg_match('/^[0-9]{1,30}$/u', trim($_COOKIE['lastin'])))||(trim($_COOKIE['lastin'])<(time()-5*3600))){echo '<h1>Your session has been expired!</h1><p>Please <a target="_new" href="../index.php">Click here </a>to start a new session.</p>';exit;}
}
private function connection()
{
        include 'database/config.php';
		$con=@new mysqli($dbhost,$dbuser,$dbpw,$dbname);
        if(mysqli_connect_errno()){return mysqli_connect_error();}
		$this->con=$con;
 		$con->set_charset("utf8");
        $query  = "SELECT* FROM ".PREFIX."settings";
        $result = $con->query($query);
        $this->site = $result->fetch_array(MYSQL_ASSOC);
		$result->free();
		$this->validate_user();return;
}
private function validate_user()
{
        $query="SELECT login, session FROM ".PREFIX."admin";
        $result=$this->con->query($query);
        $row=$result->fetch_array(MYSQL_ASSOC);
        $this->admin=(isset($_SESSION['fw_admin'])&&($_SESSION['fw_admin']===$row['session']) && ($_SERVER['REMOTE_ADDR']==$row['login']));
		$result->free();
}

public function get_query()
{
		if(!preg_match('/^([M0-9]){2,50}$/',trim($_GET['query']))){exit;}
		$query=trim(@$_GET['query']);
		$qur= explode("M", $query);
		switch ($qur[0]){
			case "1":
				$this->contact_author($qur[1]);
			break;
			case "2":
				$this->send_mail($qur[1]);
			break;
			case "3":
				$this->save_report($qur[1]);
			break;
			case "4":
				$this->save_report($qur[1],$qur[2]);
			break;
			case "5":
				$this->contact();
			break;
			case "6":
				$this->contact_admin();
			break;
			case "7":
				$this->report_post($qur[1]);
			break;
			case "8":
				$this->report_comment($qur[1],$qur[2]);
			break;
			case "9":
				$this->select_style();
			break;
			default: exit;
		}
}
private function select_style()
{
		if($this->site['userstyle']==''){exit;}
		if((isset($_GET['template']))&&(preg_match('/^([a-zA-Z0-9_\-]){1,32}$/',$_GET['template']))){
			if($_GET['template']=='-'){
				setcookie('forum_template','',time()-3600,DOCROOT);
				echo '<script>parent.location.reload(true);</script>';
			}
			elseif(is_dir('templates/'.$_GET['template'])){
				setcookie('forum_template',$_GET['template'],time()+3600*24*6,DOCROOT);
				echo '<script>parent.location.reload(true);</script>';
			}
		}
		exit;
}
private function contact_author($uid)
{
		if($this->site['allowemail']!=1){echo '<h1>Email system disabled</h1><p>Email system has been disabled by the administrator.</p>'; exit;}
		$max=$this->get_messagesize();
		$title='Contact author';
		$submit='2M'.$uid;
		$hide=true;
		include "include/contactform.php";
}
private function contact_admin()
{
		$max=$this->get_messagesize();
		$title='Contact admin';
		$submit='5M';
		include "include/contactform.php";
}
private function report_post($pid)
{
		$max=$this->get_messagesize();
		$title='Report against';
		$submit='3M'.$pid;
		include "include/contactform.php";
}
private function report_comment($pid,$cid)
{
		$max=$this->get_messagesize();
		$title='Report against';
		$submit='4M'.$pid.'M'.$cid;
		include "include/contactform.php";
}
private function get_messagesize()
{
		$result=$this->con->query("SELECT messagesize FROM ".PREFIX."mailsettings");
		$row=$result->fetch_array(MYSQL_ASSOC);
		$max=(empty($row['messagesize'])? 1000:$row['messagesize']);
		return $max;
}
private function send_mail($id)
{
		$verify=trim(fw_strip_slashes($_POST['captcha']));
		if((empty($_SESSION['fw_email_code']))||(md5($verify)!==($_SESSION['fw_email_code']))){
		fw_message(true,'Error! wrong verification code. Please try again.');
		exit;}
		unset($_SESSION['fw_email_code']);
		if(isset($_COOKIE['fw_login'])&&fw_validate_session($_COOKIE['fw_login'])){
            $login=explode('-',$_COOKIE['fw_login']);
			$sid=(int)$login[0];
			$session=$login[1];
            $query=sprintf("SELECT name, email, session FROM ".PREFIX."user WHERE id = %u AND level='C'",$sid);
            $result=$this->con->query($query);
			$row=$result->fetch_array(MYSQL_ASSOC);
            if((empty($row['session']))||(md5($row['session'])!==$session)){fw_message(true,'System error! please try again later.');exit;}
		}
		$name=$row['name'];
		$from=$row['email'];
		$today = gmdate("F j, Y, g:i a");
		$subject=trim(fw_strip_slashes($_POST['subject']));
		$message=trim(fw_strip_slashes($_POST['message']));
		$message=iconv("UTF-8", "ISO-8859-1//TRANSLIT",$message);
		$message.="\n\n--------------------------------------\n\nThis message is sent from http://".getenv('HTTP_HOST')."/\n";
		$message.="Sender I.P. ".$_SERVER['REMOTE_ADDR']."\nSender name: $name\nDate: $today GMT";
		$message.="\nIf you do not want to receive any further email from this site please login to your user control panel and uncheck \"Receive email\" option.\n";
		$message.="http://".getenv('HTTP_HOST').DOCROOT."gb/user/index.php";
		
		$query=sprintf("SELECT name, email FROM ".PREFIX."user WHERE id = %d AND allowemail = 'Y'",$id);
		$result=$this->con->query($query);
		$num=$result->num_rows;
		if($num<1){fw_message(true,'Sorry! unable to sent message.');exit;}
		$row=$result->fetch_array(MYSQL_ASSOC);
		if(@mail($row['email'],$subject, $message, 'From: '.$from)){fw_message(false,'Message has been successfully sent.');}
		else{fw_message(true,'System error! please try again later.');}
}
private function save_report($pid,$cid='')
{
		$verify=trim(fw_strip_slashes($_POST['captcha']));
		if((empty($_SESSION['fw_email_code']))||(md5($verify)!==($_SESSION['fw_email_code']))){
		fw_message(true,'Error! wrong verification code. Please try again.');
		exit;}
		unset($_SESSION['fw_email_code']);
		$dt=time();
		$name=trim(fw_strip_slashes($_POST['name']));
		$subject=trim(fw_strip_slashes($_POST['subject']));
		$from=trim(fw_strip_slashes($_POST['from']));
		if(!fw_validate_email($from)){fw_message(true,'System error! please try again later.');exit;}
		$message=trim(fw_strip_slashes(rawurldecode($_POST['message'])));
		$message.="\n\n--------------------------------------\n\n";
		$message.="Sender I.P. ".$_SERVER['REMOTE_ADDR'];
		$query="INSERT INTO ".PREFIX."report(name, subject, email, pid, cid, message, new, date) VALUES ('%s','%s','%s', %u, %u, '%s', 1, $dt)";
		$query=sprintf($query,$this->con->real_escape_string($name),$this->con->real_escape_string($subject),$this->con->real_escape_string($from),$pid,$cid,$this->con->real_escape_string($message));
		if($this->con->query($query)){fw_message(false,'Message has been successfully sent.');}
		else{fw_message(true,'System error! please try again later.');}
}

private function contact()
{
		$verify=trim(fw_strip_slashes($_POST['captcha']));
		if((empty($_SESSION['fw_email_code']))||(md5($verify)!==($_SESSION['fw_email_code']))){
		fw_message(true,'Error! wrong verification code. Please try again.');
		exit;}
		unset($_SESSION['fw_email_code']);
		$dt=time();
		$name=trim(fw_strip_slashes($_POST['name']));
		$subject=trim(fw_strip_slashes($_POST['subject']));
		$from=trim(fw_strip_slashes($_POST['from']));
		if(!fw_validate_email($from)){fw_message(true,'System error! please try again later.');exit;}
		$msg=trim(fw_strip_slashes(rawurldecode($_POST['message'])));
		$msg=iconv("UTF-8", "ISO-8859-1//TRANSLIT",$msg);
		$message=$msg."\n\n--------------------------------------\n\n";
		$message.="Sender I.P. ".$_SERVER['REMOTE_ADDR'];
		$query="INSERT INTO ".PREFIX."inbox(name,subject, email, message, new, date) VALUES ('%s','%s','%s', '%s', 1, $dt)";
		$query=sprintf($query,$this->con->real_escape_string($name),$this->con->real_escape_string($subject),$this->con->real_escape_string($from),$this->con->real_escape_string($message));
		if($this->con->query($query)){
			$result=$this->con->query("SELECT* FROM ".PREFIX."mailsettings LIMIT 0,1");
			$row=$result->fetch_array(MYSQL_ASSOC);
			if($row['autoresponder']){
				$s1=str_replace("%%SENDER%%",$name,$row['response']);
				$s1=str_replace("%%EMAIL%%",$from,$s1);
				$s1=str_replace("%%MESSAGE%%",$msg,$s1);
				@mail($from,'Re: '.$subject, $s1, 'From: '.$row['defaultfrom']);}
			fw_message(false,'Message has been successfully sent.');}
		else{fw_message(true,'System error! please try again later.');}
}
}
?>