<?php
/*
Copyright (c) 2012 http://ramui.com/. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class admin extends clsmain
{
private function show_boardsettings()
{
        $query  = "SELECT ts.*, tf.* FROM ".PREFIX."settings ts LEFT JOIN ".PREFIX."filesettings tf ON TRUE";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		$list= glob("../templates/*",GLOB_ONLYDIR);
		$option='';
		foreach ($list as $template){
			$template=str_replace("../templates/", "", $template);
			$option.=(($row['defaultstyle']==$template)? '<option selected value="' : '<option value="').$template.'">'.$template.'</option>';}
        $blocksite=(($row['blocksite'])? '<span style="color:#338833;">Unblock this site..</span>' : '<span style="color:#883333;">Block this site..</span>');
		$pagelist=$this->default_page($row['defaultpage']);
		$hmenu='<li><a href="index.php?qur=6M8">Admin settings</a></li><li><a href="javascript:fwContact(\'\')">Email settimgs</a></li><li><a href="index.php?qur=13M">RSS Settings</a></li>';
		$this->build_head("Site informations:", '<script type="text/javascript" src="script/admin.js"></script>',$hmenu);
        include "include/editsite.php";
        $this->build_footer();
}
private function default_page($id)
{
		$query="SELECT id, pagename FROM ".PREFIX."page WHERE publish = 'Y' ORDER BY id DESC LIMIT 0, 100";
        $result = @$this->con->query($query);
		$list='<option value="0"> ------ </option>';
        while($row = @$result->fetch_array(MYSQL_ASSOC)){$list.=(($row['id']==$id)? '<option selected value="' : '<option value="').$row['id'].'">'.$row['pagename'].'</option>';}
		return $list;
}
private function save_boardsettings()
{
		$allowfile=((isset($_POST["allowfile"]))? 1 : 0);
		$blockreg=((isset($_POST["blockreg"]))? 1 : 0);
		$blockspam=((isset($_POST["blockspam"]))? 1 : 0);
		$quickreply=((isset($_POST["quickreply"]))? 1 : 0);
		$fileaccess=((isset($_POST["fileaccess"]))? (($_POST["fileaccess"]==='I')? 'I' : 'A') : '');
		$sitename=trim(fw_strip_slashes(rawurldecode($_POST["sitename"])));
        $description=trim(fw_strip_slashes(rawurldecode($_POST["description"])));
        $keywords=trim(fw_strip_slashes(rawurldecode($_POST["keywords"])));
		$defaultpage=trim($_POST['defaultpage']);
		$postsize=trim($_POST["postsize"]);
		$listcount=trim($_POST["listcount"]);
		$commentcount=trim($_POST["commentcount"]);
		$linkperpost=trim($_POST["linkperpost"]);
		$linkpersign=trim($_POST["linkpersign"]);
		$signbefore=trim($_POST["signbefore"]);
		$defaultstyle=trim(fw_strip_slashes(rawurldecode($_POST["defaultstyle"])));
		$approval=((isset($_POST["approval"]))? 'A' : '');
		$nofollow=((isset($_POST["nofollow"]))? (($_POST["nofollow"]==='Y')? 'Y' : 'A') : '');
		$userstyle=((isset($_POST["userstyle"]))? (($_POST["userstyle"]==='R')? 'R' : 'A') : '');
		$allowemail=((isset($_POST["allowemail"]))? 1 : 0);
		$allowedit=((isset($_POST["allowedit"]))? 1 : 0);
		$verify=((isset($_POST["verify"]))? 1 : 0);
		$allowsign=((isset($_POST["allowsign"]))? 1 : 0);
		$description=($description);
		$description=str_replace("\n"," ",str_replace("\r","",$description));
        $query="UPDATE ".PREFIX."settings SET sitename = '%s', description = '%s', keywords = '%s', defaultpage = %d, defaultstyle = '%s', verifyuser = $verify, userstyle = '$userstyle', postsize = %d, commentcount = %d, listcount = %d, allowedit = $allowedit, quickreply = $quickreply, allowfile = $allowfile, blockreg = $blockreg, blockspam = $blockspam, fileaccess = '$fileaccess', approval = '$approval', nofollow = '$nofollow', allowemail = $allowemail, linkperpost = %u";
        $query=sprintf($query,$this->con->real_escape_string($sitename),$this->con->real_escape_string($description),$this->con->real_escape_string($keywords),$defaultpage,$this->con->real_escape_string($defaultstyle),$postsize,$commentcount,$listcount,$linkperpost);
		if($allowsign){$query.=sprintf(", allowsign = 1, linkpersign = %u, signbefore = %u",$linkpersign,$signbefore);}
		else{$query.=", allowsign = 0";}
		if(!@$this->con->query($query)){echo '<span style="color:red">Error! '.$this->con->error.'</span>';exit;}
		$size=(int)$_POST['size'];
		$fpp=(int)$_POST['fpp'];
		$height=(int)$_POST['height'];
		$width=(int)$_POST['width'];
		$extensions=trim(fw_strip_slashes(rawurldecode($_POST["extensions"])));
		$extensions=str_replace(' ','',$extensions);
		$query=sprintf("UPDATE ".PREFIX."filesettings SET size = $size, fpp = $fpp, height = $height, width = $width, extensions = '%s'",$this->con->real_escape_string($extensions));
		if(!@$this->con->query($query)){echo '<span style="color:red">Error! '.$this->con->error.'</span>';exit;}
        echo '<span style="color:green">Data has been updated.</span>';
}
private function block_site()
{
		$query = "SELECT blocksite FROM ".PREFIX."settings";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		if($row['blocksite']){$blocksite=0; $message='<span style="color:#883333;">Block this site..</span>';}
		else{$blocksite=1; $message='<span style="color:#338833;">Unblock this site..</span>';}
		if(@$this->con->query("UPDATE ".PREFIX."settings SET blocksite = $blocksite")){echo $message;}
		exit;
}
private function show_adminsettings($message='')
{
		$query="SELECT user, email FROM ".PREFIX."admin LIMIT 0,1";
        $result = @$this->con->query($query);
        $row = @$result->fetch_array(MYSQL_ASSOC);
		$this->build_head("Admin settings:",'<script type="text/javascript" src="script/admin.js"></script>','');
		include 'include/editadmin.php';
		$this->build_footer();
}
private function save_adminsettings()
{
		$message='';
		$changepass=false;
		$email=trim(fw_strip_slashes($_POST["email"]));
		$user=trim(fw_strip_slashes($_POST["user"]));
		if(!fw_validate_user($user,$email)){$message='<span style="color:red">Error! Invalid user name and / or email!</span>';}
		$password=md5(trim(fw_strip_slashes($_POST["password"])));
		$newpassword=trim(fw_strip_slashes($_POST["newpassword"]));
		$retypepassword=trim(fw_strip_slashes($_POST["retypepassword"]));
		if((!empty($newpassword))&&(!empty($retypepassword))&&($newpassword===$retypepassword)){
			$newpassword=md5($newpassword);
			$changepass=true;
			$query=sprintf("UPDATE ".PREFIX."admin SET user = '%s', email = '%s', password = '%s', login = '', session = '' WHERE password = '%s'",$this->con->real_escape_string($user),$this->con->real_escape_string($email),$this->con->real_escape_string($newpassword),$this->con->real_escape_string($password));}
		else{
			$newpassword=$password;
			$query=sprintf("UPDATE ".PREFIX."admin SET user = '%s', email = '%s', password = '%s' WHERE password = '%s'",$this->con->real_escape_string($user),$this->con->real_escape_string($email),$this->con->real_escape_string($newpassword),$this->con->real_escape_string($password));}
		if(empty($message)){
			@$this->con->query($query);
			if($this->con->affected_rows===1){
				if($changepass){$message='<span style="color:green;padding:10px;">Data has been updated. Please login again.</span>';$this->log_in($message);exit;}
				$message='<span style="color:green">Data has been updated.</span>';}
			else{$message='<span style="color:red">Sorry! Unable to update data</span>';}}
		$this->show_adminsettings($message);
}
private function show_sitemap()
{
		$filename=$_SERVER['DOCUMENT_ROOT']."/sitemap.xml";
		$sitemap=@file_get_contents($filename);
		$this->build_head("XML Sitemap:",'<script type="text/javascript" src="script/admin.js"></script>','');
		include 'include/sitemap.php';
		$this->build_footer();
}
private function generate_sitemap()
{
        $str='<?xml version="1.0" encoding="UTF-8"?>';
        $str.='<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" ';
        $str.='xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" ';
        $str.='xsi:schemaLocation="http://www.sitemaps.org/schemas/sitemap/0.9';
        $str.=' http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd">';
		$str.="\n<url><loc>".FORUM_URL."</loc></url>";
		$str.="\n<url><loc>".FORUM_URL."index.php</loc></url>";
        $query= "SELECT pagename, updated FROM ".PREFIX."page WHERE publish = 'Y' LIMIT 0,500";
		$result= @$this->con->query($query);
		while($row= @$result->fetch_array(MYSQL_ASSOC)){
			$str.="\n<url><loc>".FORUM_URL.urlencode($row['pagename']).".html</loc>";
			$str.="\n<lastmod>".gmdate("Y-m-d",$row['updated'])."</lastmod></url>";}
		$query="(SELECT 0 AS x, id, updated, fid AS tb FROM ".PREFIX."post WHERE publish = 'Y' AND pid = 0) UNION ALL (SELECT c.id AS x, tp.id, tp.updated, 0 AS tb FROM ".PREFIX."post tp JOIN (SELECT id FROM ".PREFIX."post WHERE publish = 'Y' AND pid = 0) AS c ON tp.pid = c.id WHERE tp.publish = 'Y' AND tp.pid <> 0) ORDER BY tb Desc, updated Desc LIMIT 0,500";
		$result= @$this->con->query($query);
		$f=9999;
        while($row= @$result->fetch_array(MYSQL_ASSOC)){
			if(($f!=$row['tb'])&&($f!=0)&&($row['tb']!=0)){$f=$row['tb'];$str.="\n<url><loc>".FORUM_URL."index.php?f=$f</loc></url>";}
			$str.="\n<url><loc>".FORUM_URL."index.php?t=".$row['id']."</loc>";
			$str.="\n<lastmod>".gmdate("Y-m-d",$row['updated'])."</lastmod></url>";}

		$str.='</urlset>';
        echo '<script>parent.document.frmSitemap.sitemap.value="'.fw_php2javascript($str).'";</script>';
		fw_message(false,'Successfully generated sitemap');exit;
}
private function save_sitemap()
{
		$sitemap=trim(fw_strip_slashes($_POST["sitemap"]));
		$filename=$_SERVER['DOCUMENT_ROOT']."/sitemap.xml";
		if(!@file_put_contents($filename,$sitemap)){fw_message(true,'Unable to save sitemap file. Please check file permission.');}
		else{fw_message(false,'Sitemap has been suscessfully saved!');}
		exit;
}
public function get_query($query='')
{
if ($this->validate_user()){
      switch ($query[1]) {
          case "1":
              $this->show_boardsettings();
          break;
          case "2":
              $this->save_boardsettings();
          break;
          case "3":
              $this->block_site();
          break;
          case "5":
              $this->log_out();
          break;
          case "8":
              $this->show_adminsettings();
          break;
          case "9":
              $this->save_adminsettings();
          break;
          case "10":
              $this->show_sitemap();
          break;
          case "11":
              $this->generate_sitemap();
          break;
          case "12":
              $this->save_sitemap();
          break;
          default :
              $this->show_boardsettings();
      }
}
else {if(($query[1]==1)||empty($query[1])){$this->log_in();}}
}
}
?>