<?php
/*
Copyright (c) 2012 http://ramui.com. All right reserved.
This product is protected by copyright and distributed under licenses restricting copying, distribution. Permission is granted to the public to download and use this script provided that this Notice and any statement of authorship are reproduced in every page on all copies of the script.
*/
class database
{
private $uid=false;
private $admin=false;
private $site;
public $navigation;
private $con;
public $user='';
function __construct()
{
        $message=$this->connection();
		if((($this->site['blocksite'])&&(!$this->admin))||($message)){include "gb/include/blocksite.php";exit;}
		if(DOCROOT!='/'){$this->navigation='<a href="http://'.getenv('HTTP_HOST').'/">Home</a> ';}
		$this->navigation.='<span>::</span> <a href="'.FORUM_URL.'">'.($this->site['sitename']).'</a>';
		if(($this->site['userstyle']=='A')||(($this->site['userstyle']=='R')&&($this->uid))){
			if((isset($_COOKIE['forum_template']))&&(preg_match('/^([a-zA-Z0-9_\-]){1,32}$/',$_COOKIE['forum_template']))){if(is_dir('gb/templates/'.$_COOKIE['forum_template'])){$this->site['defaultstyle']=$_COOKIE['forum_template'];}}
		}
}
private function connection()
{
        include 'gb/database/config.php';
		if(empty($dbname)||empty($dbuser)){return 'error';}
		$con=@new mysqli($dbhost,$dbuser,$dbpw,$dbname);
        if(mysqli_connect_errno()){return mysqli_connect_error();}
		$this->con=$con;
 		$con->set_charset("utf8");
        $query  = "SELECT* FROM ".PREFIX."settings";
        $result = $con->query($query);
		if($con->error){return $con->error;}
        $this->site = $result->fetch_array(MYSQL_ASSOC);
		$result->free();
		$this->validate_user();return;
}
private function validate_user()
{
        $query="SELECT login, session FROM ".PREFIX."admin";
        $result=$this->con->query($query);
        $row=$result->fetch_array(MYSQL_ASSOC);
        $this->admin=(isset($_SESSION['fw_admin'])&&($_SESSION['fw_admin']===$row['session']) && ($_SERVER['REMOTE_ADDR']==$row['login']));
		if(isset($_COOKIE['fw_login'])&&fw_validate_session($_COOKIE['fw_login'])){
            $login=explode('-',$_COOKIE['fw_login']);
			$id=(int)$login[0];
			$session=$login[1];
            $query=sprintf("SELECT session, user FROM ".PREFIX."user WHERE id = %u AND level='C'",$id);
            $result=$this->con->query($query);
			$row=$result->fetch_array(MYSQL_ASSOC);
            if((!empty($row['session']))&&(md5($row['session'])===$session)){$this->uid=$id;$this->user=$row['user'];}
		}
		$result->free();
}
public function siteinf(){return($this->site);}
public function get_page_array()
{
		if(isset($_GET['pagename'])){$row=$this->page($_GET['pagename']);}
		elseif((!empty($_GET['t']))&&(preg_match('/^[0-9]{1,8}$/u', trim($_GET['t'])))){$id=(int)($_GET['t']);$row=$this->post($id);}
		elseif((!empty($_GET['f']))&&(preg_match('/^[0-9]{1,5}$/u', trim($_GET['f'])))){$fid=(int)($_GET['f']);$row=$this->get_forum($fid);}
		elseif((!empty($_GET['uid']))&&(preg_match('/^[0-9]{1,5}$/u', trim($_GET['uid'])))){$uid=(int)($_GET['uid']);$row=$this->search_user($uid);}
		elseif(!empty($_GET['q'])){$q=xss_cleaner($_GET['q']);$row=$this->search_query($q);}
		elseif(isset($_GET['list'])&&(preg_match('/^(recentpost|noreplypost|news)$/u', $_GET['list']))){
			if($_GET['list']==='recentpost'){$row=$this->recent_post();}
			if($_GET['list']==='noreplypost'){$row=$this->noreply_post();}
			if($_GET['list']==='news'){$row=$this->news();}
		}
		else{
			if(($_SERVER['REQUEST_URI']===DOCROOT)&&(!empty($this->site['defaultpage']))){$row=$this->page();}
			else{$row=$this->get_index();}
		}
		if(empty($row['description'])){$row['description']=$this->site['description'];}
		if(empty($row['keywords'])){$row['keywords']=$this->site['keywords'];}
        return $row;
}
private function page($name='')
{
		if(!empty($name)){
			if(!fw_validate_pagename($name)){return false;}
			$query=sprintf("SELECT* FROM ".PREFIX."page WHERE pagename = '%s' AND publish = 'Y'",$this->con->real_escape_string($name));
		}
		else{$query=sprintf("SELECT* FROM ".PREFIX."page WHERE id = %d AND publish = 'Y'",$this->site['defaultpage']);}
		$result= $this->con->query($query);
		$row=$result->fetch_array(MYSQL_ASSOC);
		if(empty($row)){
			$row['title']='Page not found!';
			$this->navigation.=' <span>::</span> Page not found!';
			$row['content']=false;}
		else{
			$row['content']='<div id="fw_content">'.$row['content'].'</div>';
			if(!empty($name)){$this->navigation.=' <span>::</span> <a href="'.FORUM_URL.$name.'.html">'.$row['title'].'</a>';}
		}
		$result->free();
		return $row;
}
private function add_files($id,&$content)
{
		$query=sprintf("SELECT id, name, compressed, filesize, download FROM ".PREFIX."upload WHERE pid = %u",$id);
		$result= $this->con->query($query);
		while($row=$result->fetch_array(MYSQL_ASSOC)){
			if($row['compressed']){
				if(($this->uid)||($this->site['fileaccess'] === 'A')){$replacement='<div class="fw_attachment"><a href="gb/file.php?id='.$row['id'].'">'.$row['name'].'</a>&nbsp;['.@round(($row['filesize']/1024),1).' Kb]<br /><br /><span>**Downloaded '.$row['download'].' time'.(($row['download']>1)? 's':'').'</div>';}
				else{$replacement='<div class="fw_inactive">'.$row['name'].'<br /><br /><span>**Please login to download.</div>';}
			}
			else{
				if(($this->uid)||($this->site['fileaccess'] === 'A')||($this->site['fileaccess'] === 'I')){$replacement='<div class="fw_image"><img title="'.$row['name'].'" src="gb/file.php?id='.$row['id'].'" alt="'.$row['name'].'" /></div>';}
				else{$replacement='<div class="fw_inactive">'.$row['name'].'<br /><br /><span>**Please login to view image.</div>';}
			}
			$content=str_replace('[file]'.$row['name'].'[/file]',$replacement,$content);
		}
		$result->free();
}
private function get_news($id)
{
		@$this->con->query(sprintf("UPDATE ".PREFIX."post SET view = view+1 WHERE id = %u AND publish ='Y'",$id));
		$query=sprintf("SELECT* FROM ".PREFIX."post WHERE  id = %u AND pid = 0 AND publish = 'Y' AND fid = 0",$id);
		$result= $this->con->query($query);
		$row=$result->fetch_array(MYSQL_ASSOC);
		$this->navigation.=' <span>::</span> <a href="index.php?list=news">News</a> <span>::</span> <a href="index.php?t='.$id.'">'.$row['title'].'</a>';
		$updated=($row['date']==$row['updated'])? '':gmdate("M d, Y, H:i",$row['updated']);
		$nofollow=(($this->site['nofollow']=='Y')||($this->site['nofollow']=='A'));
		$bb= new bbcode($nofollow,false);
		$row['content']=$bb->format_text($row['content'],$row['autolink']);
		unset($bb);
		$this->add_files($id,$row['content']);
		$title='<a href="index.php?t='.$id.'">'.$row['title'].'</a>';
		$str=file_get_contents('gb/templates/'.$this->site['defaultstyle'].'/structure/news.txt');
		$str=preg_replace("/<updated>(.+)<\/updated>/eiUs","\$this->format_updated(\$updated,'\\1')", $str);
		$edit=($this->admin)? '<a class="fw_edit" target="_new" href="gb/admin/index.php?qur=14M1M'.$id.'">Edit</a>':'';
		$row['content']=str_replace(array('__&TITLE__','__&CONTENT__','__&POSTDATE__','__&EDIT__'),array($title,$row['content'],gmdate("M d, Y, H:i",$row['date']),$edit),$str);
		return $row;
}
private function news()
{
		if((isset($_GET['page']))&&(preg_match('/^[0-9]{1,2}$/u', trim($_GET['page'])))){$page=(int)$_GET['page'];}
		if(empty($page)){$page=1;}
		$this->navigation.=' <span>::</span> <a href="index.php?list=news">News</a>';
		$arr=array();
		$arr['title']='Admin news';
		$query="SELECT id FROM ".PREFIX."post WHERE pid = 0 AND publish = 'Y' AND fid = 0";
		$result= $this->con->query($query);
		$num_rows=$result->num_rows;
		if(empty($num_rows)){$arr['content']='<h1>No news from Administrator</h1>';return $arr;}
		$start_count=($page-1)*$this->site['listcount'];
		$totalpage=fw_total_page($num_rows, $this->site['listcount']);
		$query="select id, title, description, date, updated, view from ".PREFIX."post where publish = 'Y' AND pid = 0 AND fid = 0 ORDER BY updated desc LIMIT $start_count, ".$this->site['listcount'];
		$result= $this->con->query($query);
		$str=file_get_contents('gb/templates/'.$this->site['defaultstyle'].'/structure/newslist.txt');
		$newstxt=fw_gettag('news',$str);
		$str=preg_replace('/\<news\>(.+)\<\/news\>/Us','',$str);
		$newslist='';
		$lastvisit=((isset($_COOKIE['currentsession']))&&(preg_match('/^[0-9]{1,30}$/u', trim($_COOKIE['currentsession']))))? trim($_COOKIE['currentsession']):0;
		while($row=$result->fetch_array(MYSQL_ASSOC)){
			$unread=(($row['date']>$lastvisit)?'<img title="New" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/unread.gif"':'<img title="Old" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/read.gif"').' />';
			$newslist.=str_replace(array('__&UNREAD__','__&NEWSTITLE__','__&DATE__','__&VIEW__','__&DESCRIPTION__'),array($unread,'<a href="index.php?t='.$row['id'].'">'.$row['title'].'</a>',gmdate("M d, Y, H:i",$row['date']),$row['view'],$row['description']),$newstxt);
		}
		$result->free();
		$arr['content']=str_replace('__&NEWSLIST__',$newslist,$str);
		if($totalpage>1){
			$href='index.php?list=news';
			if($page>1){$this->navigation.=' <span>::</span> <a href="index.php?list=news&page='.$page.'">Page'.$page.'</a>';}
			$pagelink='<div id="fw_pageno"><b>NO OF PAGES:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';
			$start=(($page>10)? $page-10 : 1);
			$end=(($totalpage<=21)? $totalpage : $start+20);
			$pagelink.=(($page>1)? '<a href="'.$href.(($page>2)? '&page='.($page-1) : '').'">Back</a>&nbsp;' : '<span>Back</span>&nbsp;');
			for($p=$start; $p<=$end; $p++){
				if($p==$page){$pagelink.='<span>['.$p.']</span>&nbsp;';}
				else{$pagelink.='[<a href="'.$href.(($p>1)? '&page='.$p : '').'">'.$p.'</a>]&nbsp;';}
			}
			$pagelink.=(($page<$totalpage)? '<a href="'.$href.'&page='.($page+1).'">Next</a>&nbsp;' : '<span>Next</span>&nbsp;');
			$pagelink.='</div>';
			$arr['pagelink']=$pagelink;}
		return $arr;
}
private function post($id)
{
        $query=sprintf("select id, pid, fid from ".PREFIX."post where publish = 'Y' AND id = %u",$id);
		$result= $this->con->query($query);
		$row=$result->fetch_array(MYSQL_ASSOC);
		if(empty($row)){
			$row['title']='Page not found!';
			$this->navigation.=' <span>::</span> Page not found!';
			$row['content']=false;return $row;}
		if(empty($row['pid'])&&empty($row['fid'])){return $this->get_news($id);}
		$b=(empty($row['pid']));
		$result->free();
		$page=1;
		if($b){
			if((isset($_GET['page']))&&(preg_match('/^[0-9]{1,2}$/u', trim($_GET['page'])))){$page=(int)$_GET['page'];}
			if($page<2){$page=1;$this->con->query(sprintf("UPDATE ".PREFIX."post SET view = view+1 WHERE id = %u AND publish ='Y'",$id));}
			$query=(($page>1)? "SELECT tp.title, tp.fid, tp.description, tp.keywords, tp.locked":"SELECT tp.*").", u.*, tf.title AS ftitle, tf.description AS fdescription, tf.parent, tf.keywords AS fkeywords,tf.locked AS flocked FROM
			".PREFIX."post tp LEFT JOIN " 
			.PREFIX."forum tf ON tp.fid = tf.id LEFT JOIN 
			(SELECT tu.id as userid, tu.user, tu.date AS dateuser, tu.signature, tu.autolink AS signautolink, tu.allowemail, tu.level, count(y.id) as cc, if(isnull(z.postcount), 0, z.postcount) as pc
			from ".PREFIX."user tu left join 
			(select count(id) as postcount, uid from ".PREFIX."post where publish = 'Y' and pid = 0 group by uid) as z on tu.id = z.uid left join 
			(select x.* from
			(select id,uid, pid from ".PREFIX."post where publish = 'Y' and pid<>0) as x join ".PREFIX."post p on x.pid = p.id where p.publish ='Y') as y
			on tu.id = y.uid group by tu.id) AS u ON tp.uid = u.userid WHERE tp.id =%u";
		}
		else{
			$query="SELECT tp.*, p.title AS posttitle, u.*, tf.title AS ftitle, tf.description AS fdescription, tf.keywords AS fkeywords, tf.parent, tf.locked AS flocked FROM
			".PREFIX."post tp LEFT JOIN 
			(SELECT id, title, fid FROM ".PREFIX."post WHERE publish = 'Y') AS p ON tp.pid = p.id LEFT JOIN "
			.PREFIX."forum tf ON p.fid = tf.id LEFT JOIN 
			(SELECT tu.id as userid, tu.user, tu.date AS dateuser, tu.signature, tu.autolink AS signautolink, tu.allowemail, tu.level, count(y.id) as cc, if(isnull(z.postcount), 0, z.postcount) as pc
			from ".PREFIX."user tu left join 
			(select count(id) as postcount, uid from ".PREFIX."post where publish = 'Y' and pid = 0 group by uid) as z on tu.id = z.uid left join 
			(select x.* from
			(select id,uid, pid from ".PREFIX."post where publish = 'Y' and pid<>0) as x join ".PREFIX."post p on x.pid = p.id where p.publish ='Y') as y
			on tu.id = y.uid group by tu.id) AS u ON tp.uid = u.userid WHERE tp.id =%u";
		}
		$query = sprintf($query,$id);
		$result=$this->con->query($query);
		$row=$result->fetch_array(MYSQL_ASSOC);
		$result->free();
		$this->navigation.=' <span>::</span> '.((empty($row['parent']))? '':' <span>::</span> ').'<a href="index.php?f='.$row['fid'].'">'.$row['ftitle'].'</a> <span>::</span> '.(!empty($row['pid'])? '<a href="index.php?t='.$row['pid'].'">'.$row['posttitle'].'</a> <span>::</span> ':'').'<a href="index.php?t='.$id.'">'.$row['title'].'</a>';
		$locked=(($row['locked']=='Y')||($row['flocked']=='Y'));
		if(($page>1)&&$b){$this->navigation.=' <span>::</span> <a href="index.php?t='.$id.'&page='.$page.'">page'.$page.'</a>';}
		if(!$row['description']){$row['description']=$row['fdescription'];}
		if(!$row['keywords']){$row['keywords']=$row['fkeywords'];}
		if(($page<2)||!$b){
			$autolink=($row['autolink']);
			$nofollow=(($this->site['nofollow']=='Y')||($this->site['nofollow']=='A'));
			$bb= new bbcode($nofollow,0,false);
			$content=$bb->format_text($row['content'],$row['autolink']);
			$signature='';
			$backtopost='';
			$newtopic='';
			$reply='';
			$contact=((($row['allowemail']=='Y')&&($this->site['allowemail'])&&($row['level']=='C')&&($this->uid))? '<a class="fw_mail" href="javascript:fwOpenMail(\'1M'.$row['uid'].'\')">Contact</a>' : '<span>Contact</span>');
			$report='<a class="fw_report" href="javascript:fwOpenMail(\'7M'.$id.'\')">Report</a>';
			$edit='';
			if((($this->site['allowedit'])&&(!empty($this->uid))&&($this->uid==$row['uid'])&&(!$locked)&&$b)||($this->admin)){$edit='<a class="fw_edit" target="_new" href="gb/user/index.php?query=1M3M'.$row['id'].'">Edit</a>';}
			if((!($this->site['signbefore']>($row['pc']+$row['cc'])))&&($this->site['allowsign'])&&($row['level']=='C')){
				$bb= new bbcode($nofollow,true);
				$signature=$bb->format_text($row['signature'],$row['signautolink']);}
			unset($bb);
			$this->add_files($id,$content);
			$updated=($row['date']==$row['updated'])? '':gmdate("M d, Y, H:i",$row['updated']);
			if($b){
				$newtopic=($row['flocked']=='Y')? '<span>New topic</span>' : '<a class="fw_newtopic" target="_new" href="gb/user/index.php?query=1M1M'.$row['fid'].'">New topic</a>';
				$reply=(($locked)? '<span>Reply</span>':'<a class="fw_reply" target="_new" href="gb/user/index.php?query=2M1M'.$id.'">Reply</a>');
			}
			else{$backtopost='<a class="fw_backtopic" href="index.php?t='.$row['pid'].'">Back to Post</a>';}
			$str=file_get_contents('gb/templates/'.$this->site['defaultstyle'].'/structure/post.txt');
			$symbols=array('__&CONTENT__','__&POSTDATE__','__&TITLE__','__&POSTCOUNT__','__&COMMENTCOUNT__','__&USER__','__&DATEOFJOIN__','__&BACKTOPOST__','__&NEWTOPIC__','__&REPLY__','__&CONTACT__','__&REPORT__','__&EDIT__');
			$replacements=array($content,gmdate("M d, Y, H:i",$row['date']),'<a href="index.php?t='.$id.'">'.$row['title'].'</a>',$row['pc'],$row['cc'],'<a title="Post('.$row['pc'].') + Comments('.$row['cc'].')" href="index.php?uid='.$row['uid'].'">'.$row['user'].'</a>',gmdate("M d, Y, H:i",$row['dateuser']),$backtopost,$newtopic,$reply,$contact,$report,$edit);
			$str=str_replace($symbols,$replacements,$str);
			unset($symbols,$replacements);
			$str=preg_replace("/<signature>(.+)<\/signature>/eiUs","\$this->format_signature(\$signature,'\\1')", $str);
			$str=preg_replace("/<updated>(.+)<\/updated>/eiUs","\$this->format_updated(\$updated,'\\1')", $str);
			$row['content']=$str;}
		
        if(($this->uid)&&(!$locked)&&($this->site['quickreply'])){
			$str=file_get_contents('gb/templates/'.$this->site['defaultstyle'].'/structure/quickreply.txt');
			if($b){
				$qid=$id;
				$qtitle=substr('Re: '.$row['title'],0,75);
			}
			else{
				$qid=$row['pid'];
				$qtitle=substr('Re: '.$row['posttitle'],0,75);
			}
			$row['quickreply']=str_replace(array('__&PID__','__&MAXLENGTH__','__&TITLE__'),array($qid,$this->site['postsize'],$qtitle),$str);
		}
		$row['title'].=' - '.$id.(($page>1)? ' : Page '.$page : '');
		$comments=$this->get_comments($id,$page,$locked);
		if(!empty($comments)){
			if(!isset($row['content'])){$row['content']='';}
			$row['content'].=$comments['content'];
			if(isset($comments['backnext'])){$row['backnext']=$comments['backnext'];}
			if(isset($comments['pagelink'])){$row['pagelink']=$comments['pagelink'];}
		}
		return $row;
}
private function format_signature($signature,$text)
{
		return (empty($signature)? '': str_replace('__&SIGNATURE__',$signature,$text));
}
private function format_updated($updated,$text)
{
		return (empty($updated)? '': str_replace('__&UPDATED__',$updated,$text));
}
private function get_comments($id,$page,$locked)
{
		$query=sprintf("SELECT id FROM ".PREFIX."post WHERE pid = %u AND publish = 'Y'",$id);
		$result= $this->con->query($query);
		$num_rows=$result->num_rows;
		if(empty($num_rows)){return false;}
		$start_count=($page-1)*$this->site['commentcount'];
		$totalpage=fw_total_page($num_rows, $this->site['commentcount']);
		$query="select tp.*, v.* from ".PREFIX."post tp left join
		(SELECT tu.id as userid, tu.user, tu.date AS dateuser, tu.signature, tu.autolink AS signautolink, tu.allowemail, tu.level, count(y.id) as cc, if(isnull(z.postcount), 0, z.postcount) as pc
		from ".PREFIX."user tu left join 
		(select count(id) as postcount, uid from ".PREFIX."post where publish = 'Y' and pid = 0 group by uid) as z on tu.id = z.uid left join 
		(select x.* from
		(select id,uid, pid from ".PREFIX."post where publish = 'Y' and pid<>0) as x join ".PREFIX."post p on x.pid = p.id where p.publish ='Y') as y
		on tu.id = y.uid group by tu.id) as v on tp.uid = v.userid where tp.pid = %u and tp.publish = 'Y' ORDER BY tp.id Asc LIMIT ".$start_count.", ".$this->site['commentcount'];
		$query=sprintf($query,$id);
		$result= $this->con->query($query);
        $str='';
		$str1=file_get_contents('gb/templates/'.$this->site['defaultstyle'].'/structure/comments.txt');
		$symbols=array('__&CONTENT__','__&POSTDATE__','__&TITLE__','__&POSTCOUNT__','__&COMMENTCOUNT__','__&USER__','__&DATEOFJOIN__','__&CONTACT__','__&REPORT__','__&EDIT__');
		$nofollow=(($this->site['nofollow']=='Y')||($this->site['nofollow']=='A'));
        while($row=$result->fetch_array(MYSQL_ASSOC)){
			$autolink=($row['autolink']);
			$bb= new bbcode($nofollow,false);
			$content=$bb->format_text($row['content'],$autolink);
			$signature='';
			$reply='';
			$edit='';
			if((($this->site['allowedit'])&&(!empty($this->uid))&&($this->uid==$row['uid'])&&(!$locked))||($this->admin)){$edit='<a class="fw_edit" target="_new" href="gb/user/index.php?query=2M3M'.$row['id'].'">Edit</a>';}
			$updated=($row['date']==$row['updated'])? '':gmdate("M d, Y, H:i",$row['updated']);
			$report='<a class="fw_report" href="javascript:fwOpenMail(\'8M'.$id.'M'.$row['id'].'\')">Report</a>';
			$contact=((($row['allowemail']=='Y')&&($this->site['allowemail'])&&($row['level']=='C')&&($this->uid))? '<a class="fw_mail" href="javascript:fwOpenMail(\'1M'.$row['uid'].'\')">Contact</a>' : '<span>Contact</span>');
			if((!($this->site['signbefore']>($row['pc']+$row['cc'])))&&($this->site['allowsign'])&&($row['level']=='C')){
				$bb= new bbcode($nofollow,true);
				$signature=$bb->format_text($row['signature'],$row['signautolink']);}
			unset($bb);
			$this->add_files($row['id'],$content);
			$replacements=array($content,gmdate("M d, Y, H:i",$row['date']),'<a href="index.php?t='.$row['id'].'">'.$row['title'].'</a>',$row['pc'],$row['cc'],'<a title="Post('.$row['pc'].') + Comments('.$row['cc'].')" href="index.php?uid='.$row['uid'].'">'.$row['user'].'</a>',gmdate("M d, Y, H:i",$row['dateuser']),$contact,$report,$edit);
			$str2=str_replace($symbols,$replacements,$str1);
			$str2=preg_replace("/<signature>(.+)<\/signature>/eiUs","\$this->format_signature(\$signature,'\\1')", $str2);
			$str.=preg_replace("/<updated>(.+)<\/updated>/eiUs","\$this->format_updated(\$updated,'\\1')", $str2);
		}
		$result->free();
		unset($symbols,$replacements);
		$arr=array();
		if($totalpage >1){
			$backnext=($page>1)? '<a title="Previous page" href="index.php?t='.$id.(($page>2)? '&page='.($page-1) : '').'"><img class="fw_backnext" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/back.gif" /></a>' : '<img class="fw_backnext" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/back_fed.gif" />';
			$backnext.=($page<$totalpage)? '<a title="Next page" href="index.php?t='.$id.'&page='.($page+1).'"><img class="fw_backnext" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/next.gif" /></a>&nbsp;' : '<img class="fw_backnext" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/next_fed.gif" />';
			$pagelink='<div id="fw_pageno"><b>NO OF PAGES:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';
			$start=(($page>10)? $page-10 : 1);
			$end=(($totalpage<=21)? $totalpage : $start+20);
			$pagelink.=(($page>1)? '<a href="index.php?t='.$id.(($page>2)? '&page='.($page-1) : '').'">Back</a>&nbsp;' : '<span>Back</span>&nbsp;');
			for($p=$start; $p<=$end; $p++){
				if($p==$page){$pagelink.='<span>['.$p.']</span>&nbsp;';}
				else{$pagelink.='[<a href="index.php?t='.$id.(($p>1)? '&page='.$p : '').'">'.$p.'</a>]&nbsp;';}
			}
			$pagelink.=(($page<$totalpage)? '<a href="index.php?t='.$id.'&page='.($page+1).'">Next</a>&nbsp;' : '<span>Next</span>&nbsp;');
			$pagelink.='</div>';
			$arr['backnext']=$backnext;
			$arr['pagelink']=$pagelink;}
		$arr['content']=$str;
        return $arr;
}
private function get_index()
{
		$cat=array();
		$forum=array();
		$str='';
		$query="SELECT tf.id AS forumid, tf.title AS ftitle, tf.cid AS catid, tf.sdescription, tf.locked, tf.icon, IF(ISNULL(f.fc), 0, f.fc) AS forumcount, tcc.icon AS caticon, if( isnull( tcc.title ) , 'No Category:', tcc.title ) AS ctitle, t.u AS userid, t.d AS lastdate, if( isnull( count( t.id ) ) , 0, count( t.id ) ) AS postcount, if( isnull( sum( t.c1 ) ) , 0, sum( t.c1 ) ) AS commentcount, tu.user
		FROM ".PREFIX."forum tf
		LEFT JOIN (
		SELECT tp.id, tp.fid, if(isnull(tc.uid) , tp.uid, tc.uid) AS u, if(isnull(tc.uid), tp.date, tc.dm) AS d, if(isnull(tc.c) , 0, tc.c) AS c1
		FROM ".PREFIX."post tp
		LEFT JOIN(
		SELECT x.pid, x.uid, max(x.date) as dm, count(x.id) AS c FROM 
		(SELECT id, pid, uid, date FROM ".PREFIX."post
		WHERE pid <>0
		AND publish = 'Y'
		ORDER BY id DESC) AS x GROUP BY x.pid
		) AS tc ON tp.id = tc.pid
		WHERE tp.pid =0
		AND tp.publish = 'Y'
		ORDER BY d DESC
		) AS t ON tf.id = t.fid
		LEFT JOIN (SELECT parent, COUNT(id) AS fc FROM ".PREFIX."forum WHERE parent > 0 GROUP BY parent) AS f ON f.parent = tf.id 
		LEFT JOIN ".PREFIX."category tcc ON tf.cid = tcc.id
		LEFT JOIN ".PREFIX."user tu ON t.u = tu.id
		WHERE tf.parent =0
		GROUP BY tf.id
		ORDER BY tcc.position DESC , tf.position DESC
		LIMIT 0 , 100";
        $result=$this->con->query($query);
		$x=file_get_contents('gb/templates/'.$this->site['defaultstyle'].'/structure/index.txt');
		$cattxt=fw_gettag('category',$x);
		$forumtxt=fw_gettag('forum',$x);
		$lastvisit=((isset($_COOKIE['currentsession']))&&(preg_match('/^[0-9]{1,30}$/u', trim($_COOKIE['currentsession']))))? trim($_COOKIE['currentsession']):0;
		while($row=$result->fetch_array(MYSQL_ASSOC)){
			$img='<img src="gb/'.((is_file('gb/icon/'.$row['icon']))? 'icon/'.$row['icon'] : 'templates/'.$this->site['defaultstyle'].'/images/icon/forum.gif').'" />';
			if($row['locked']==='Y'){$img='<img title="Locked" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/locked.gif" alt="L" />';}
			if(empty($cat[$row['catid']])){$cat[$row['catid']]=str_replace('__&CATIMAGE__','<img src="'.((is_file('gb/icon/'.$row['caticon']))? 'gb/icon/'.$row['caticon'] : 'gb/templates/'.$this->site['defaultstyle'].'/images/icon/category.gif').'" alt="L" />',str_replace('__&CATTITLE__',$row['ctitle'],$cattxt));}
			$unread=(($row['lastdate']>$lastvisit)?'<img title="New Message" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/unread.gif"':'<img title="No New Message" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/read.gif"').' />';
			@$forum[$row['catid']].=str_replace(array('__&FORUMICON__','__&UNREAD__','__&FORUMTITLE__','__&SMALLDESCRIPTION__','__&FORUMCOUNT__','__&POSTCOUNT__','__&COMMENTCOUNT__','__&LASTUSER__'),array($img,$unread,'<a href="index.php?f='.$row['forumid'].'">'.$row['ftitle'].'</a>',$row['sdescription'],$row['forumcount'],(empty($row['postcount'])? 0 : $row['postcount']),(empty($row['commentcount'])? 0 : $row['commentcount']),(empty($row['user'])? '-' : 'By: <a href="index.php?uid='.$row['userid'].'">'.$row['user'].'</a><br />on : '.gmdate("M d, Y, H:i", $row['lastdate']))),$forumtxt);
		}
		$result->free();
		foreach($cat as $k => $c){$str.=str_replace('__&FORUMS__',$forum[$k],$c);}
		unset($cat,$forum);
		$x=preg_replace('/\<forum\>(.+)\<\/forum\>/Us','',$x);
		$x=preg_replace('/\<category\>(.+)\<\/category\>/Us',$str,$x);
		$arr=array();
		$arr['content']=$x;
        return $arr;
}
private function get_forum($fid)
{
		$str='';
		$query="SELECT tf.id AS forumid, tf.title AS ftitle, tf.sdescription, tf.locked, tf.icon, IF(ISNULL(f.fc), 0, f.fc) AS forumcount, t.u AS userid, t.d AS lastdate, if( isnull( count( t.id ) ) , 0, count( t.id ) ) AS postcount, if( isnull( sum( t.c1 ) ) , 0, sum( t.c1 ) ) AS commentcount, tu.user
		FROM ".PREFIX."forum tf
		LEFT JOIN (
		SELECT tp.id, tp.fid, if(isnull(tc.uid) , tp.uid, tc.uid) AS u, if(isnull(tc.uid), tp.date, tc.dm) AS d, if(isnull(tc.c) , 0, tc.c) AS c1
		FROM ".PREFIX."post tp
		LEFT JOIN(
		SELECT x.pid, x.uid, max(x.date) as dm, count(x.id) AS c FROM 
		(SELECT id, pid, uid, date FROM ".PREFIX."post
		WHERE pid <>0
		AND publish = 'Y'
		ORDER BY id DESC) AS x GROUP BY x.pid
		) AS tc ON tp.id = tc.pid
		WHERE tp.pid =0
		AND tp.publish = 'Y'
		ORDER BY d DESC
		) AS t ON tf.id = t.fid
		LEFT JOIN (SELECT parent, COUNT(id) AS fc FROM ".PREFIX."forum WHERE parent > 0 GROUP BY parent) AS f ON f.parent = tf.id 
		LEFT JOIN ".PREFIX."user tu ON t.u = tu.id
		WHERE tf.parent =%u
		GROUP BY tf.id
		ORDER BY tf.position DESC , tf.position DESC
		LIMIT 0 , 100";
		$query=sprintf($query,$fid);
		$result=$this->con->query($query);
		$x=file_get_contents('gb/templates/'.$this->site['defaultstyle'].'/structure/forum.txt');
		$forumtxt=fw_gettag('forum',$x);
		$find=array('__&FORUMICON__','__&UNREAD__','__&FORUMTITLE__','__&SMALLDESCRIPTION__','__&FORUMCOUNT__','__&POSTCOUNT__','__&COMMENTCOUNT__','__&LASTUSER__');
		$lastvisit=((isset($_COOKIE['currentsession']))&&(preg_match('/^[0-9]{1,30}$/u', trim($_COOKIE['currentsession']))))? trim($_COOKIE['currentsession']):0;
		while($row=$result->fetch_array(MYSQL_ASSOC)){
			$img='<img src="gb/'.((is_file('gb/icon/'.$row['icon']))? 'icon/'.$row['icon'] : 'templates/'.$this->site['defaultstyle'].'/images/icon/forum.gif').'" />';
			if($row['locked']==='Y'){$img='<img title="Locked" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/locked.gif" alt="L" />';}
			$unread=(($row['lastdate']>$lastvisit)?'<img title="New Topics" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/unread.gif"':'<img title="No New Topic" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/read.gif"').' />';
			$str.=str_replace($find,array($img,$unread,'<a href="index.php?f='.$row['forumid'].'">'.$row['ftitle'].'</a>',$row['sdescription'],$row['forumcount'],(empty($row['postcount'])? 0 : $row['postcount']),(empty($row['commentcount'])? 0 : $row['commentcount']),(empty($row['user'])? '-' : 'By: <a href="index.php?uid='.$row['userid'].'">'.$row['user'].'</a><br />on : '.gmdate("M d, Y, H:i", $row['lastdate']))),$forumtxt);
		}
		$result->free();
		if(!empty($str)){$str=str_replace('__&FORUMS__',$str,fw_gettag('forumlist',$x));}

		$arr=array();
		$page=1;
		if((isset($_GET['page']))&&(preg_match('/^[0-9]{1,2}$/u', trim($_GET['page'])))){$page=(int)$_GET['page'];}
		if($page<2){$page=1;}
		$query=sprintf("SELECT t.title as ptitle, t.parent AS pparent, tf.parent, tf.title, tf.description, tf.keywords, tf.locked, tf.icon FROM ".PREFIX."forum tf LEFT JOIN (SELECT id, title, parent FROM ".PREFIX."forum) AS t ON tf.parent = t.id WHERE tf.id = %u",$fid);
		$result=$this->con->query($query);
		$row=$result->fetch_array(MYSQL_ASSOC);
		$locked=($row['locked']=='Y');
		$icon='<img src="'.(($locked)? 'gb/templates/'.$this->site['defaultstyle'].'/images/icon/locked.gif' : ((is_file('gb/icon/'.$row['icon']))? 'gb/icon/'.$row['icon']:'gb/templates/'.$this->site['defaultstyle'].'/images/icon/forum.gif')).'" />';
		$arr['title']=$row['title'].(($page>1)? ' : Page - '.$page : '');
		$arr['description']=$row['description'];
		$this->navigation.=' <span>::</span> '.(empty($row['parent'])? '': (empty($row['pparent'])? '':' <span>::</span> ').'<a href="index.php?f='.$row['parent'].'">'.$row['ptitle'].'</a> <span>::</span> ').'<a href="index.php?f='.$fid.'">'.$row['title'].'</a>'.(($page>1)? ' <span>::</span> <a href="index.php?f='.$fid.'&page='.$page.'">Page '.$page.'</a>':'');
		$post='';
		$posttxt=fw_gettag('post',$x);
		$find=array('__&UNREAD__','__&POSTICON__','__&FILEICON__','__&POSTTITLE__','__&POSTDESCRIPTION__','__&POSTVIEW__','__&FILECOUNT__','__&COMMENTCOUNT__','__&LASTUSER__');
		$num_rows=$this->totalpost($fid);
		$totalpage=1;
		if($num_rows){
			$start_count=($page-1)*($this->site['listcount']);
			$totalpage=fw_total_page($num_rows, ($this->site['listcount']));
			$query=sprintf("SELECT b.*, tu.user FROM (SELECT tp.id, IF(ISNULL( d.up), 0, d.up) as u1, IF(ISNULL(sum(tc.up)), 0, sum(tc.up)) as u2, tp.locked, tp.title, tp.description, tp.view, IF(ISNULL(tc.id), 0,COUNT(tc.id)) AS c, IF(ISNULL(tc.date), tp.date, MAX(tc.date)) as m, IF(ISNULL(tc.date), tp.uid, tc.uid) AS u FROM ".PREFIX."post tp left join (select pid, count(id) as up from ".PREFIX."upload group by pid) as d on tp.id = d.pid LEFT JOIN (SELECT a.id, a.pid, a.uid, a.date, a.publish, b.up FROM ".PREFIX."post a left join (select pid, count(id) as up from ".PREFIX."upload group by pid) as b on a.id = b.pid WHERE a.publish = 'Y' AND a.pid <>0 order by a.id desc) AS tc on tp.id=tc.pid WHERE tp.fid = %u AND tp.publish = 'Y' group by tp.id order by m desc LIMIT ".$start_count.", ".$this->site['listcount'].") AS b LEFT JOIN ".PREFIX."user tu ON tu.id = b.u",$fid);
			$result=$this->con->query($query);
			while($row=$result->fetch_array(MYSQL_ASSOC)){
				$img='<img src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/'.(($row['locked']==='Y')? 'locked.gif' : 'post.gif').'" />';
				$attachment='';
				if($row['u1']+$row['u2']){$attachment=(is_file('gb/templates/'.$this->site['defaultstyle'].'/images/icon/attachment.gif')? '<img src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/attachment.gif" />':'<img src="gb/images/icon/attachment.gif" />');}
				$unread=(($row['m']>$lastvisit)?'<img title="New" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/unread.gif"':'<img title="Old" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/read.gif"').' />';
				$post.=str_replace($find,array($unread,$img,$attachment,'<a href="index.php?t='.$row['id'].'">'.$row['title'].'</a>',$row['description'],$row['view'],($row['u1']+$row['u2']),$row['c'],'<a href="index.php?uid='.$row['u'].'">'.$row['user'].'</a> : '.gmdate("M d, Y, H:i",$row['m'])),$posttxt);
			}
			$result->free();
		}
		$x=preg_replace('/\<forum\>(.+)\<\/forum\>/Us','',$x);
		$x=preg_replace('/\<forumlist\>(.+)\<\/forumlist\>/Us','',$x);
		$x=preg_replace('/\<post\>(.+)\<\/post\>/Us','',$x);
		$find=array('__&FORUMICON__','__&POSTLIST__','__&NEWTOPIC__');
		$str.=str_replace($find,array($icon,$post,(($locked)? '<span>New topic</span>':'<a class="fw_newtopic" target="_new" href="gb/user/index.php?query=1M1M'.$fid.'">New topic</a>')),$x);
		unset($find);
		$href='index.php?f='.$fid;
		if($totalpage>1){
			$backnext=($page>1)? '<a title="Previous page" href="index.php?f='.$fid.(($page>2)? '&page='.($page-1) : '').'"><img class="fw_backnext" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/back.gif" /></a>' : '<img class="fw_backnext" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/back_fed.gif" />';
			$backnext.=($page<$totalpage)? '<a title="Next page" href="index.php?f='.$fid.'&page='.($page+1).'"><img class="fw_backnext" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/next.gif" /></a>&nbsp;' : '<img class="fw_backnext" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/next_fed.gif" />';
			$pagelink='<div id="fw_pageno"><b>NO OF PAGES:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';
			$start=(($page>10)? $page-10 : 1);
			$end=(($totalpage<=21)? $totalpage : $start+20);
			$pagelink.=(($page>1)? '<a href="'.$href.(($page>2)? '&page='.($page-1) : '').'">Back</a>&nbsp;' : '<span>Back</span>&nbsp;');
			for($p=$start; $p<=$end; $p++){
				if($p==$page){$pagelink.='<span>['.$p.']</span>&nbsp;';}
				else{$pagelink.='[<a href="'.$href.(($p>1)? '&page='.$p : '').'">'.$p.'</a>]&nbsp;';}
			}
			$pagelink.=(($page<$totalpage)? '<a href="'.$href.'&page='.($page+1).'">Next</a>&nbsp;' : '<span>Next</span>&nbsp;');
			$pagelink.='</div>';
			$arr['backnext']=$backnext;
			$arr['pagelink']=$pagelink;}
		$arr['content']=$str;
        return $arr;
}
private function recent_post()
{
		$arr=array();
		$arr['title']='Recent Post';
		$lastvisit=((isset($_COOKIE['currentsession']))&&(preg_match('/^[0-9]{1,30}$/u', trim($_COOKIE['currentsession']))))? trim($_COOKIE['currentsession']):0;
		$str='';
		$this->navigation.=' <span>::</span> <a href="index.php?list=recentpost">Recent post</a>';
		$query="SELECT t.id as verified, tp.id, tp.pid, tp.fid, tp.uid, tp.locked, tp.title, tp.view, tp.date, tu.user FROM (select id from ".PREFIX."post where publish='Y' AND pid = 0) as t LEFT JOIN ".PREFIX."post tp on if((tp.pid=0), (t.id=tp.id), (t.id = tp.pid)) LEFT JOIN ".PREFIX."user tu on tp.uid=tu.id order by tp.date desc LIMIT 0, ".$this->site['listcount'];
		$result= $this->con->query($query);
		$x=file_get_contents('gb/templates/'.$this->site['defaultstyle'].'/structure/recentpost.txt');
		$posttxt=fw_gettag('post',$x);
		$x=preg_replace('/\<post\>(.+)\<\/post\>/Us','',$x);
		$find=array('__&POSTICON__','__&UNREAD__','__&POSTTITLE__','__&POSTVIEW__','__&USER__','__&DATE__');
		while($row=$result->fetch_array(MYSQL_ASSOC)){
			$img='<img src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/';
			if(empty($row['pid'])&&empty($row['fid'])){$img.='news.gif" />';}
			else{$img.=(($row['pid'])? 'comment.gif' :(($row['locked']==='Y')? 'locked.gif' : 'post.gif')).'" />';}
			$unread=(($row['date']>$lastvisit)?'<img title="New" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/unread.gif"':'<img title="Old" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/read.gif"').' />';
			$str.=str_replace($find,array($img,$unread,'<a class="'.(($row['date']>$lastvisit)? 'unread':'read').'" href="index.php?t='.$row['id'].'">'.$row['title'].'</a>',(($row['pid'])? '-' : $row['view']),$row['user'],gmdate("M d, Y, H:i",$row['date'])),$posttxt);
		}
		$result->free();
		unset($find);
		$str=str_replace('__&POSTLIST__',$str,$x);
		$arr['content']=$str;
		return $arr;
}
private function noreply_post()
{
		$arr=array();
		$arr['title']='Unanswered Post';
		$str='';
		$page=1;
		if((isset($_GET['page']))&&(preg_match('/^[0-9]{1,2}$/u', trim($_GET['page'])))){$page=(int)$_GET['page'];}
		if($page<2){$page=1;}
		$this->navigation.=' <span>::</span> <a href="index.php?list=noreplypost">Unanswered post</a>';
		$query="select id from ".PREFIX."post where id not in (select pid from ".PREFIX."post where pid <> 0 group by pid) and pid = 0 AND fid <> 0 and publish = 'Y'";
		$result= $this->con->query($query);
		$num_rows=$result->num_rows;
		$x=file_get_contents('gb/templates/'.$this->site['defaultstyle'].'/structure/unansweredpost.txt');
		$posttxt=fw_gettag('post',$x);
		$x=preg_replace('/\<post\>(.+)\<\/post\>/Us','',$x);

		if($num_rows){
			if($page>1){$this->navigation.=' :: <a href="index.php?list=noreplypost&Page='.$page.'">Page'.$page.'</a>';$arr['title'].=' : Page - '.$page;}
			$start_count=($page-1)*($this->site['listcount']);
			$totalpage=fw_total_page($num_rows, ($this->site['listcount']));
			$query="select tp.id, tp.fid, tp.uid, tp.view, tp.locked as pl, tp.title, tp.date, tf.locked as fl, tu.user from ".PREFIX."post tp left join ".PREFIX."forum tf on tp.fid = tf.id left join ".PREFIX."user tu on tp.uid = tu.id where tp.id not in (select pid from ".PREFIX."post where pid <> 0 group by pid) and tp.pid = 0 AND tp.fid <> 0 and tp.publish = 'Y' order by tp.date desc LIMIT ".$start_count.", ".$this->site['listcount'];
			$result= $this->con->query($query);
			$find=array('__&POSTICON__','__&POSTTITLE__','__&POSTVIEW__','__&USER__','__&DATE__');
			while($row=$result->fetch_array(MYSQL_ASSOC)){
				$img='<img src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/'.((($row['fl']==='Y')||($row['pl']==='Y'))? 'locked.gif' : 'post.gif').'" />';
				$str.=str_replace($find,array($img,'<a href="index.php?t='.$row['id'].'">'.$row['title'].'</a>',$row['view'],$row['user'],gmdate("M d, Y, H:i",$row['date'])),$posttxt);
			}
			$result->free();
			unset($find);
		}
		$str=str_replace('__&POSTLIST__',$str,$x);
		if(!empty($totalpage)){
			$href="index.php?list=noreplypost";
			$pagelink='<div id="fw_pageno"><b>NO OF PAGES:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';
			$start=(($page>10)? $page-10 : 1);
			$end=(($totalpage<=21)? $totalpage : $start+20);
			$pagelink.=(($page>1)? '<a href="'.$href.(($page>2)? '&page='.($page-1) : '').'">Back</a>&nbsp;' : '<span>Back</span>&nbsp;');
			for($p=$start; $p<=$end; $p++){
				if($p==$page){$pagelink.='<span>['.$p.']</span>&nbsp;';}
				else{$pagelink.='[<a href="'.$href.(($p>1)? '&page='.$p : '').'">'.$p.'</a>]&nbsp;';}
			}
			$pagelink.=(($page<$totalpage)? '<a href="'.$href.'&page='.($page+1).'">Next</a>&nbsp;' : '<span>Next</span>&nbsp;');
			$pagelink.='</div>';
			$arr['pagelink']=$pagelink;}
		$arr['content']=$str;
		return $arr;
}
private function search_query($str)
{
		$arr=array();
		$str=trim($str);
		$l=strlen($str);
		$num=0;
		if(($l>80)||($l<3)){
			$s=(($l>80)? 'Too long':'Too short').' search query!';
			$arr['title']=$s;
			$this->navigation.=' <span>::</span> '.$s;
			$num=0;
		}
		else{
			$str_escape=$this->con->real_escape_string($str);
			$query=sprintf("SELECT id FROM ".PREFIX."user WHERE user = '%s' AND level = 'C'",$str_escape);
			$result=$this->con->query($query);
			$row=$result->fetch_array(MYSQL_ASSOC);
			if(!empty($row)){return $this->search_user($row['id']);}
			$query="SELECT ts.title, ts.description, tp.pagename, ts.pid, ts.cid, ts.uid, MATCH (ts.title,ts.body,ts.keywords,ts.description) AGAINST ('%s' IN NATURAL LANGUAGE MODE) AS score ";
			$query.="FROM ".PREFIX."search ts LEFT JOIN ".PREFIX."page tp ON ts.pageid = tp.id WHERE (MATCH (ts.title,ts.body,ts.keywords,ts.description) AGAINST ('%s' IN NATURAL LANGUAGE MODE))>.5 AND ts.publish = 'Y' LIMIT 0,50";
			$query=sprintf($query,$str_escape,$str_escape);
			$result=$this->con->query($query);
			$num=$result->num_rows;
			$s='Search: '.$str;
			$this->navigation.=' <span>::</span> <a href="index.php?q='.urlencode($str).'">Search result >> '.$str.'</a>';
			$arr['title']='Search result: '.$str;
		}
		$x=file_get_contents('gb/templates/'.$this->site['defaultstyle'].'/structure/searchquery.txt');
		$posttxt=fw_gettag('post',$x);
		$x=preg_replace('/\<post\>(.+)\<\/post\>/Us','',$x);
		$find=array('__&POSTICON__','__&POSTTITLE__','__&POSTDESCRIPTION__','__&SCORE__');
		$post='';
		while($row=$result->fetch_array(MYSQL_ASSOC)){
			if(!empty($row['pagename'])){
				$title='<a href="'.$row['pagename'].'.html">'.$row['title'].'</a>';
				$icon='<img title="Page" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/html.gif" />';
			}
			else{
				if(empty($row['cid'])){
					$title='<a href="index.php?t='.$row['pid'];
					$icon=(empty($row['uid'])? '<img title="News" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/news.gif" />':'<img title="Post" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/post.gif" />');
				}
				else{
					$title='<a href="index.php?t='.$row['cid'];
					$icon='<img title="Comment" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/comment.gif" />';
				}
				$title.='">'.$row['title'].'</a>';
			}
			$post.=str_replace($find,array($icon,$title,$row['description'],(round($row['score'],2)*10)),$posttxt);
		}
		$result->free();
		$find=array('__&NUM__','__&SEARCH__','__&POSTLIST__');
		$x=str_replace($find,array($num,$s,$post),$x);
		$arr['content']=$x;
		return $arr;
}
private function search_user($id)
{
		$arr=array();
		$page=1;
		if((isset($_GET['page']))&&(preg_match('/^[0-9]{1,2}$/u', trim($_GET['page'])))){$page=(int)$_GET['page'];}
		if($page<2){$page=1;}
		$query="SELECT tu.user, tu.website, tu.date AS dateuser, tu.allowemail, tu.level, count(y.id) as cc, if(isnull(z.postcount), 0, z.postcount) as pc
		from ".PREFIX."user tu left join 
		(select count(id) as postcount, uid from ".PREFIX."post where publish = 'Y' and pid = 0 group by uid) as z on tu.id = z.uid left join 
		(select x.* from
		(select id,uid, pid from ".PREFIX."post where publish = 'Y' and pid<>0) as x join ".PREFIX."post p on x.pid = p.id where p.publish ='Y') as y
		on tu.id = y.uid WHERE tu.id = %u AND (tu.level = 'C' OR tu.level = 'B')";
		$query=sprintf($query,$id);
		$result= $this->con->query($query);
		$row=$result->fetch_array(MYSQL_ASSOC);
		$user=$row['user'];
		if(empty($user)){
			$date_of_join='-';
			$arr['title']='User not found';
			$this->navigation.=' <span>::</span> User not found';
		}
		else{
			$date_of_join=gmdate("M d, Y, H:i",$row['dateuser']);
			$arr['title']='Post by: '.$user;
			$this->navigation.=' <span>::</span> <a href="index.php?uid='.$id.'">'.$user.'</a>';
		}
		$allowemail=(($row['allowemail']=='Y')&&($row['level']=='C')&&($this->site['allowemail'])&&($this->uid));
		$home=(($row['level']=='C')&&(!empty($row['website'])))? '<a class="fw_website" target="_blank" href="'.$row['website'].'">Visit website</a>' : '<span class="fw_website">Visit website</span>';
		$totalpost =$row['pc']+$row['cc'];
		$x=file_get_contents('gb/templates/'.$this->site['defaultstyle'].'/structure/searchuser.txt');
		$posttxt=fw_gettag('post',$x);
		$x=preg_replace('/\<post\>(.+)\<\/post\>/Us','',$x);
		$post='';
		if(!empty($user)){
			$start_count=($page-1)*$this->site['listcount'];
			$totalpage=fw_total_page($totalpost, $this->site['listcount']);
			$query="(SELECT id, title, locked, date, 0 AS verify FROM ".PREFIX."post WHERE publish = 'Y' AND pid = 0 AND uid = %u) UNION ALL
			(SELECT tp.id, tp.title, tp.locked, tp.date, t.id AS verify FROM ".PREFIX."post tp JOIN
			(SELECT id FROM ".PREFIX."post WHERE publish = 'Y' AND pid = 0) AS t ON tp.pid = t.id WHERE tp.publish = 'Y' AND tp.pid <> 0 AND tp.uid = %u) ORDER BY date desc LIMIT ".$start_count.", ".$this->site['listcount'];
			$query=sprintf($query,$id,$id);
			$result=$this->con->query($query);
			$post_icon='<img title="Post" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/post.gif" />';
			$locked_icon='<img title="Locked" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/locked.gif" />';
			$comment_icon='<img title="Comment" src="gb/templates/'.$this->site['defaultstyle'].'/images/icon/comment.gif" />';
			$find=array('__&POSTICON__','__&POSTTITLE__','__&DATE__');
			while($row=$result->fetch_array(MYSQL_ASSOC)){
				$post.=str_replace($find,array((($row['verify'])? $comment_icon : (($row['locked']=='Y')? $locked_icon : $post_icon)),'<a href="index.php?t='.$row['id'].'">'.$row['title'].'</a>',gmdate("M d, Y, H:i",$row['date'])),$posttxt);
			}
			$result->free();
		}
		$find=array('__&TOTALPOST__','__&USER__','__&DATEUSER__','__&POSTLIST__','__&HOMEPAGE__','__&CONTACT__');
		$x=str_replace($find,array($totalpost,$user,$date_of_join,$post,$home,(($allowemail)? '<a class="fw_mail" href="javascript:fwOpenMail(\'1M'.$id.'\')">Contact</a>' : '<span>Contact</span>')),$x);
		$arr['content']=$x;
		
		if($totalpage>1){
			$href='index.php?uid='.$id;
			if($page>1){$this->navigation.=' <span>::</span> <a href="index.php?uid='.$id.'&page='.$page.'">Page'.$page.'</a>';}
			$pagelink='<div id="fw_pageno"><b>NO OF PAGES:&nbsp;'.$totalpage.'</b>&nbsp;&nbsp;&nbsp;';
			$start=(($page>10)? $page-10 : 1);
			$end=(($totalpage<=21)? $totalpage : $start+20);
			$pagelink.=(($page>1)? '<a href="'.$href.(($page>2)? '&page='.($page-1) : '').'">Back</a>&nbsp;' : '<span>Back</span>&nbsp;');
			for($p=$start; $p<=$end; $p++){
				if($p==$page){$pagelink.='<span>['.$p.']</span>&nbsp;';}
				else{$pagelink.='[<a href="'.$href.(($p>1)? '&page='.$p : '').'">'.$p.'</a>]&nbsp;';}
			}
			$pagelink.=(($page<$totalpage)? '<a href="'.$href.'&page='.($page+1).'">Next</a>&nbsp;' : '<span>Next</span>&nbsp;');
			$pagelink.='</div>';
			$arr['pagelink']=$pagelink;}
		return $arr;
}
public function totalpost($fid)
{
		$query=sprintf("SELECT id FROM ".PREFIX."post WHERE publish = 'Y' AND pid = 0 AND fid = %u",$fid);
		$result=$this->con->query($query);
		return $result->num_rows;
}
public function getpage($n)
{
		$query=sprintf("SELECT pagename, title FROM ".PREFIX."page WHERE publish = 'Y' ORDER BY id Desc LIMIT 0,%u",$n);
		$result= $this->con->query($query);
		$str='';
		while($row=$result->fetch_array(MYSQL_ASSOC)){
			$link=urlencode($row['pagename']).'.html';
			$anchor=(strlen($row['title'])>32)? substr($row['title'],0,30).'..' : $row['title'];
			$str.='<li><a title="'.$row['title'].'" href="'.$link.'">'.$anchor.'</a></li>';
		}
		return $str;
}
public function getuid()
{
		return(empty($this->uid)? false:$this->uid);
}
public function get_templates()
{
		if(($this->site['userstyle']=='')||(($this->site['userstyle']=='R')&&(!$this->uid))){return false;}
		$list= glob("gb/templates/*",GLOB_ONLYDIR);
		if(count($list)<2){return false;}
		$option='<li><a href="#" onclick="return fwSelectUserStyle(\'-\')">Use Default Style</a></li>';
		foreach ($list as $template){
			$template=str_replace("gb/templates/", "", $template);
			$option.=(($this->site['defaultstyle']==$template)? '<li>'.$template.' (In use)</li>':'<li><a href="#" onclick="return fwSelectUserStyle(\''.addslashes($template).'\')">'.$template.'</a></li>');
		}
		return $option;
}
}
?>